$regfile = "m8def.dat"
$crystal = 8000000
$hwstack = 32
$swstack = 96
$framesize = 64
'$baud = 19200


On Int0 Bindstart                                           ' Interrrupt for the start bits
On Timer2 Readbindbit                                       ' Timer interrupt for 24us bit interval

Config Pinc.0 = Input                                       ' bind plug (d7)
Bindpin Alias Pinc.0
Set Portc.0                                                 ' bind plug pullup
Config Pinc.1 = Output                                      ' led pin
Ledpin Alias Portc.1
Config Pind.2 = Output
Datapindir Alias Pind.2                                     'satelite data pin
Datapin Alias Portd.2
Config Pind.3 = Output
Powerpin Alias Portd.3                                      'satelite power pin
Config Int0 = Low Level
Config Timer2 = Timer , Prescale = 1                        ' timer2 is used for decoding satellite data
'Config Timer1 = Timer , Prescale = 8
Const Timerconst = 129                                      '125                                      '118                                      '215                                      '215,216                                      'timer const for bit interval. will fit 213 '215                                      'Nosave
Const Satpw = 21                                            '21, 22, 23 - works!!!


Dim Bindbits(100) As Byte At $60                            '$100                           ' bits array. SRAM address $100 should be changed to fit MC
Dim Guid(10) As Byte At $c4                                 '$164                               ' ID array. SRAM address $180 should be changed to fit MC
Dim Oguid(10) As Byte At $ce                                '$16e
Dim Chan(162) As Byte At $d8                                '$178                               'channel data holder (startbit+16bits+stopbit)x9=162
Dim Chanval(9) As Word At $17a                              '$21a
Dim Failchanval(9) As Word At $18c                          '$22c
'Dim Temp(9) As Word

Config Portb = Output                                       ' all servos are attached here

Dim Tempval As Word
Dim Bindbitcounter As Byte
Dim Bindbit As Byte
Dim Sguidbit As Byte
Dim Chancount As Byte

'
Dim I As Byte                                               ' general use counter
Dim J As Byte                                               ' general use counter
Dim Tval As Byte
Dim Gbit As Byte
Dim D As Byte
Dim Dand1 As Byte
Dim Chanbit As Byte
Dim Bitcount As Byte
Dim Decodecount As Byte
Dim Temp As Word
'Dim Tempbyte As Byte
'Dim Tempword As Word
Dim B As Byte
Dim X As Byte
Dim Satmode As Bit                                          ' if satmode is set, than it is binding condition
Dim Failsave As Bit


'EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE eeprom EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
$eeprom                                                     ' dummy byte for 00 cell
Iddummy:
Data 1
Id:                                                         ' the storage for guid
Data 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 , 10 , 11
Faildata:                                                   ' default failsave for channels (in microseconds)
Data 1500% , 1500% , 1000% , 1500% , 1500% , 1500% , 1500% , 1500%
$data
'EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE eeprom EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE


Declare Sub Saveguid
Declare Sub Sendguid
Declare Sub Getguidbits
Declare Sub Sendguidbit
Declare Sub Radiodecodemode
Declare Sub Decodechan
Declare Sub Printchan

'************************** POWER ON ***************************************************
'Reset Ledpin
Failsave = 0
Portb = 0                                                   '
Reset Satmode                                               ' Set to normal mode
Waitms 600
'Print "Starting..."
Set Datapin                                                 ' log.1 on datapin
'Print "Reset RX"
Reset Powerpin                                              ' Power off the satelite
Waitms 600

'---------------------- Bind check -----------------------------------------------------
If Bindpin = 0 Then                                         ' Bind plug check
   Set Powerpin                                             ' If in bind mode - satelite power on
   Set Satmode                                              ' mode = bindining
   Reset Datapin                                            ' set datapin to low
   Waitms 130                                               ' wait for 130ms  to enter binding mode
   'Print "Bind mode..."
   Config Datapindir = Input
   Reset Datapin                                            ' reset datapin
   Waitms 100
   Enable Interrupts
   Config Int0 = Low Level
   Enable Int0
   Bindbit = 0
   Bindbitcounter = 0
   Timer2 = Timerconst
   Enable Timer2
   Wait 15
Else                                                        ' if no bind plug, then enter normal mode
   'Print "No Bind plug"

   Config Datapindir = Output
   'Print "Reset RX"
   Reset Powerpin
   Waitms 600
   Set Powerpin
   'Print "RX Live"

   Gosub Sendguid                                           ' send GUID to satellite
   Config Datapindir = Input
   Gosub Radiodecodemode                                    ' decode data - receive mode
End If


'MMMMMMMMMMMMMMMMMMMMMMMMMMMMMM MAIN CYCLE MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
'MMMMMMMMMMMMMMMMMMMMMMMMMMMMMM    START   MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
'MMMMMMMMMMMMMMMMMMMMMMMMMMMMMM MAIN CYCLE MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
Do

If Bindpin = 0 Then                                         ' may be you want to save new values to failsave?
  Disable Interrupts
  For B = 1 To 8
   X = 9 + B
   X = X + B
   Writeeeprom Chanval(b) , X                               ' write to eeprom current channel data
   'Print Chanval(b)
  Next B
  Set Ledpin
  Waitms 100
  Reset Ledpin
  Waitms 100
  Set Ledpin
  Waitms 100
  Reset Ledpin
  Waitms 100
  Set Ledpin
  Waitms 100
  Reset Ledpin
  Waitms 100
  Set Ledpin
  Waitms 100
  Reset Ledpin
  Waitms 100
  Wait 1                                                    ' wait for a while
  Enable Interrupts
End If
                           '******* FAILSAFE ********
If Failsave = 1 Then                                        ' We have problem with radio - failsafe mode
  'Set Ledpin
  'Pulseout Portc , 1 , 8000
  Disable Interrupts
  For B = 1 To 8
   X = 9 + B
   X = X + B
   Readeeprom Failchanval(b) , X                            ' read failsafe data from eeprom
   'Print Failchanval(b)
  Next B
  Enable Interrupts
  For B = 1 To 8
   Chanval(b) = Failchanval(b)
  Next B

Gosub Printchan
Waitms 4
End If
Failsave = 1
Waitms 10
                           '******* FAILSAFE ********

nop                                                         '******* Normal Mode *****
Loop

'MMMMMMMMMMMMMMMMMMMMMMMMMMMMMM MAIN CYCLE MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
'MMMMMMMMMMMMMMMMMMMMMMMMMMMMMM     END    MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
'MMMMMMMMMMMMMMMMMMMMMMMMMMMMMM MAIN CYCLE MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM



'############################ INT0 INTERRUPT ##############################################
Bindstart:                                                  ' start bit interrupt
Failsave = 0
Set Ledpin
Disable Int0
Enable Timer2
Timer2 = Timerconst
Start Timer2

Return


'########################### TIMER2 INTERRUPT ############################################
Readbindbit:                                                ' timer bit interval (every 24us)
'Reset Ledpin
'Failsave = 0
If Satmode = 1 Then                                         '&&&&&&&&&&&&&&&&&&binding mode!
   Timer2 = Timerconst
   Start Timer2
   Bindbits(bindbit) = Datapindir                           ' read datapin and store it value in the array
   Incr Bindbit                                             ' increment bit number

      If Bindbit = 98 Then                                  'if bindbit = 98 then guid complete
         Stop Timer2
         'Print "All 100"
         Call Saveguid                                      ' we need to save guid in eeprom
      End If

   Incr Bindbitcounter                                      ' if 9 bits received
      If Bindbitcounter = 9 Then                            ' then one data is received
                                                             ' and it is time to
         Stop Timer2
         'Print "9 bits"                                        ' enable start bit interrupt
         Bindbitcounter = 0
         Enable Int0                                        ' wait for next start bit of next byte
      End If

Else                                                        '&&&&&&&&&&&&&&&&&&&&&&&Normal mode

   Timer2 = Timerconst
   Start Timer2

   'may need to skip start bit
   Chan(chanbit) = Datapindir
   Incr Chanbit
   Incr Bitcount

  If Bitcount = 18 Then                                     '   // channel data complete, skip stop bit
    Stop Timer2                                             ' // stop timer
    Bitcount = 0
    Incr Chancount
      If Chancount > 8 Then
         Stop Timer2
         Gosub Decodechan
      End If
    Enable Int0                                             '  // wait for next stop bit
  End If

End If

Return



'########################## saving guid in eeprom ############################################
Sub Saveguid                                                ' sub for saving guid in eeprom

   Bindbit = 98
   'Print "++++++++++++++++++++++"
      For I = 9 To 0 Step -1                                ' we have 10 bytes in guid
         Tval = 0
         Decr Bindbit                                       ' skip the start bit
            For J = 0 To 7                                  ' we have 8 bits of data in each guid byte
               'Print Bindbits(b)
               Shift Tval , Left                            ' shift byte to left
               Tval = Tval Or Bindbits(bindbit)             ' ORing byte with bit value (reading byte bit by bit)
               Decr Bindbit                                 ' next bit in array
            Next J
         'Print Tval                                         ' next bit in byte
         Guid(i) = Tval
      Next I                                                ' save byte in array
   'Print "Binding DONE"

   Disable Interrupts
   For I = 1 To 10
      Writeeeprom Guid(i -1) , I                            'writing
   Next I
   Enable Interrupts                                        'guid
   'Print "ID Saved in EEPROM"                               ' in EEPROM

End Sub


'########################## send guid to satellite ############################################
Sub Sendguid
  Waitms 500
  Gosub Getguidbits
  Gosub Sendguidbit
  'Print "GUID sent"
End Sub


'########################## send guid by bit to satellite ############################################
Sub Sendguidbit
  Sguidbit = 0
  For I = 0 To 9
    'Print "next bit"
    Waitus 130                                              '550
    For J = 0 To 9
      Datapin = Bindbits(sguidbit)
      'Print Bindbits(sguidbit)
      Incr Sguidbit
      Waitus Satpw
    Next J
  Next I
'Set Ledpin
End Sub


'########################## load guid from eeprom ############################################
Sub Getguidbits
  Bindbit = 0

  Disable Interrupts
  For I = 1 To 10                                           'we read eeprom from end to begin (ID is stored in such way)
    'X = 10 - I
    Readeeprom Guid(i -1) , I
    'Oguid(i) = Guid(i)
    'Print Guid(i)                                           ', Dec
  Next I
  Enable Interrupts

  For I = 0 To 9
    Bindbits(bindbit) = 0                                   ';  // start bit
    Incr Bindbit
    D = Guid(i)
    For J = 0 To 7
      Dand1 = D And 1
      If Dand1 = 1 Then
       Gbit = 1
      Else
       Gbit = 0
      End If
      Bindbits(bindbit) = Gbit
      'Print Bindbits(bindbit)
      Incr Bindbit
      Shift D , Right
    Next J
    'Print "stop:"
    Bindbits(bindbit) = 1                                   ' // stop bit
    'Print Bindbits(bindbit)
    Incr Bindbit
  Next I

  'For I = 0 To 9
  'Print Guid(i)
  'Next I

End Sub


'########################## decoding mode ############################################

Sub Radiodecodemode
  Config Datapindir = Input
  'Print "Decode Mode"
  Enable Interrupts
  Timer2 = Timerconst
  Enable Timer2
  Chancount = 0
  Chanbit = 0
  Bitcount = 0
  Config Int0 = Low Level                                   'start the channel start interrupt - wait for first start bit
  Enable Int0
End Sub


'########################## decoding channel data from satellite ############################################
Sub Decodechan                                              '

D = 160                                                     '160 159                                                     '71   bit index
  For I = 9 To 1 Step -1
    Tempval = 0                                             '            // reset the channel accum
    Decr D                                                  '  // skip stop bit
    'print("")
     For J = 0 To 15
      Shift Tempval , Left
      Tempval = Tempval Or Chan(d)
      Decr D
    Next J
    Decr D                                                  '// skip start bit

    Chanval(i) = Tempval
'    Shift Tempval , Left
 '   Shift Tempval , Left
 '   Temp(i) = Tempval
  Next I
Gosub Printchan                                             ' servo output
  Incr Decodecount
  Chancount = 0
  Chanbit = 0
End Sub


'########################## servo output ############################################
Sub Printchan

'   Print Hex(chanval(1)) ; " " ; Hex(chanval(8))            '; Chanval(2) ; " " ; Chanval(3) ; " " ; Chanval(4) ; " " ; Chanval(5)      'Chanval(0)
   ' Channel 1 output
   Temp = Chanval(1)                                        ' load channel data
   Shift Temp , Left                                        ' because we use 16MHz than we should muliply
'   Shift Temp , Left                                        ' channel data by 4 to use Pulseout im microseconds
   Pulseout Portb , 6 , Temp

   ' Channel 2 output
   Temp = Chanval(2)
   Shift Temp , Left
'   Shift Temp , Left
   Pulseout Portb , 7 , Temp

   ' Channel 3 output
   Temp = Chanval(3)
   Shift Temp , Left
'   Shift Temp , Left
   Pulseout Portb , 0 , Temp

   ' Channel 4 output
   Temp = Chanval(4)
   Shift Temp , Left
'   Shift Temp , Left
   Pulseout Portb , 1 , Temp

   ' Channel 5 output
   Temp = Chanval(5)
   Shift Temp , Left
'   Shift Temp , Left
   Pulseout Portb , 2 , Temp

   ' Channel 6 output
   Temp = Chanval(6)
   Shift Temp , Left
'   Shift Temp , Left
   Pulseout Portb , 3 , Temp

   ' Channel 7 output
   Temp = Chanval(7)
   Shift Temp , Left
'   Shift Temp , Left
   Pulseout Portb , 4 , Temp

   ' Channel 8 output
   Temp = Chanval(8)
   Shift Temp , Left
'   Shift Temp , Left
   Pulseout Portb , 5 , Temp

End Sub



End